## cp2k 2.6.2

=== makefiles/Makefile ===
#
# make -j 16 sopt popt ssmp psmp
#
# will now perform a parallel build of 4 cp2k executables
#
.SUFFIXES: .F .dep .o .f90 .cu .c .instantiation .instantiated .template
SHELL = /bin/sh
#
# the home dir is taken from the current directory: you must cd to the makefiles
# directory before executing make.
# adding a symbolic link from the src directory to the Makefile in makefiles/
# also works fine
#
CP2KHOME     := $(abspath $(PWD)/..)
ARCH         := $(shell $(CP2KHOME)/tools/build_utils/get_arch_code)
export VERSION=sopt

MAKEFILE     := $(CP2KHOME)/makefiles/Makefile
DOXYGENDIR   := $(CP2KHOME)/doc/doxygen
MAINEXEDIR   := $(CP2KHOME)/exe
MAINLIBDIR   := $(CP2KHOME)/lib
MAINOBJDIR   := $(CP2KHOME)/obj
PRETTYOBJDIR := $(CP2KHOME)/obj/prettified
DOXIFYOBJDIR := $(CP2KHOME)/obj/doxified
INSTANTIATEDDIR := $(CP2KHOME)/obj/instantiated
TOOLSRC      := $(CP2KHOME)/tools
SRCDIR       := $(CP2KHOME)/src
EXEDIR       := $(MAINEXEDIR)/$(ARCH)
REVISION     := $(shell $(CP2KHOME)/tools/build_utils/get_revision_number $(SRCDIR))


# Discover programs =========================================================
ifeq ($(ALL_EXE_FILES),)
export ALL_EXE_FILES := $(sort $(shell $(TOOLSRC)/build_utils/discover_programs.py $(SRCDIR)))
endif
EXE_NAMES := $(basename $(notdir $(ALL_EXE_FILES)))

# Once we are down to a single version ======================================
# this only happens on stage 3 and 4
ifneq ($(ONEVERSION),)
MODDEPS = "lower"
include $(CP2KHOME)/arch/$(ARCH).$(ONEVERSION)
LIBDIR  := $(MAINLIBDIR)/$(ARCH)/$(ONEVERSION)
OBJDIR  := $(MAINOBJDIR)/$(ARCH)/$(ONEVERSION)
ifeq ($(NVCC),)
EXE_NAMES := $(basename $(notdir $(filter-out %.cu, $(ALL_EXE_FILES))))
endif
ifneq ($(LD_SHARED),)
 ARCHIVE_EXT := .$(ONEVERSION).so
else
 ARCHIVE_EXT := .a
endif
endif

# Declare PHONY targets =====================================================
.PHONY : $(VERSION) $(EXE_NAMES) \
         dirs makedep default_target all \
         toolversions libcp2k \
         doxifydir doxify doxifyclean \
         prettydir pretty prettyclean doxygen/clean doxygen \
         install clean realclean distclean mrproper help templates \
         instantiationdir templatesclean


# Discover files and directories ============================================
ALL_SRC_DIRS := $(shell find $(SRCDIR) -type d ! -name preprettify  ! -path "*/.svn*" | awk '{printf("%s:",$$1)}')
LIBCUSMM_DIR := $(shell find $(SRCDIR) -type d -name "libcusmm")
ALL_PREPRETTY_DIRS = $(shell find $(SRCDIR) -type d -name preprettify)

ALL_PKG_FILES  = $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "PACKAGE")
OBJ_SRC_FILES  = $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.F")
OBJ_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.c")
ALL_INST_FILES = $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.instantiation")

ifneq ($(NVCC),)
OBJ_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" ! -name "libcusmm.cu" -name "*.cu")
OBJ_SRC_FILES += $(LIBCUSMM_DIR)/libcusmm.cu
endif

# Include also source files which won't compile into an object file
ALL_SRC_FILES  = $(OBJ_SRC_FILES)
ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.f90")
ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.h")

ALL_OBJECTS        = $(addsuffix .o, $(basename $(notdir $(OBJ_SRC_FILES))))
ALL_EXE_OBJECTS    = $(addsuffix .o, $(EXE_NAMES))
ALL_NONEXE_OBJECTS = $(filter-out $(ALL_EXE_OBJECTS), $(ALL_OBJECTS))

# Common Targets ============================================================
default_target: all

# stage 1: Call make recursively with each element in $(VERSION) as a target,
#          The actual target is stored in ORIG_TARGET.
#          Make can then parallelize over multiple versions targets.
ifeq ($(ONEVERSION),)
ORIG_TARGET = default_target

fes :
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(VERSION) ORIG_TARGET=graph

$(EXE_NAMES) all toolversions libcp2k:
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(VERSION) ORIG_TARGET=$@

# stage 2: Store the version target in $(ONEVERSION),
#          Call make recursively with $(ORIG_TARGET) as target.
$(VERSION) :
	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(ORIG_TARGET) ORIG_TARGET="" VERSION="" ONEVERSION=$@

else

# stage 3: Include arch-file, create dirs, and run makedep.py for given $(ONEVERSION).
#          Afterwards, call make recursively again with -C $(OBJDIR) and INCLUDE_DEPS=true
ifeq ($(INCLUDE_DEPS),)
$(EXE_NAMES): dirs makedep
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) $(EXEDIR)/$@.$(ONEVERSION) INCLUDE_DEPS=true

all: dirs makedep
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) all INCLUDE_DEPS=true

libcp2k: dirs makedep
	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) $(LIBDIR)/libcp2k$(ARCHIVE_EXT) INCLUDE_DEPS=true

dirs:
	@mkdir -p $(OBJDIR)
	@mkdir -p $(LIBDIR)
	@mkdir -p $(EXEDIR)

toolversions:
ifneq ($(FC),)
	@echo "=========== FC ($(ONEVERSION)) ==========="
	$(FC) --version
endif
ifneq ($(CC),)
	@echo "=========== CC ($(ONEVERSION)) ==========="
	$(CC) --version
endif
ifneq ($(NVCC),)
	@echo "========== NVCC ($(ONEVERSION)) =========="
	$(NVCC) --version
	@echo ""
endif
ifneq ($(AR),)
	@echo "=========== AR ($(ONEVERSION)) ==========="
	$(firstword $(AR)) V
	@echo ""
endif
else

# stage 4: Include $(OBJDIR)/all.dep, expand target all and libcp2k, and perform actual build.
all: $(foreach e, $(EXE_NAMES), $(EXEDIR)/$(e).$(ONEVERSION))
$(LIBDIR)/libcp2k$(ARCHIVE_EXT) : $(ALL_NONEXE_OBJECTS)

endif
endif

OTHER_HELP += "toolversions : Print versions of build tools"

#   extract help text from doxygen "\brief"-tag
help:
	@echo "=================== Binaries ===================="
	@echo "all                         Builds all executables (default target)"
	@for i in $(ALL_EXE_FILES); do \
	basename  $$i | sed 's/^\(.*\)\..*/\1/' | awk '{printf "%-28s", $$1}'; \
	grep "brief" $$i | head -n 1 | sed 's/^.*\\brief\s*//'; \
	done
	@echo "libcp2k                     Builds CP2K as a single library archive"
	@echo ""
	@echo "===================== Tools ====================="
	@printf "%s\n" $(TOOL_HELP) | awk -F ':' '{printf "%-28s%s\n", $$1, $$2}'
	@echo ""
	@echo "================= Other Targets ================="
	@printf "%s\n" $(OTHER_HELP) | awk -F ':' '{printf "%-28s%s\n", $$1, $$2}'
	@echo "help                         Print this help text"

#
# so far CP2K does not install, but give a hint to the user
#
install:
	@echo ""
	@echo "The CP2K executable is $(foreach v, $(VERSION), $(EXEDIR)/cp2k.$(v))"
	@echo ""
OTHER_HELP += "install : Print installation help"

#
# delete the intermediate files, but not the libraries and executables, or created directories.
# Most useful to save space on the disk or e.g. for recompiles with PGO that still needs the .gcda files in the objdir
#
# cleaning stuff ============================================================
clean:
	rm -rf  $(LIBCUSMM_DIR)/libcusmm.cu
	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.o)
	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.mod $(MAINOBJDIR)/$(ARCH)/$(v)/*.MOD) 
	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.dep) 
OTHER_HELP += "clean : Remove intermediate object and mod files, but not the libraries and executables, for given ARCH and VERSION"

#
# delete the intermediate files, the programs and libraries and anything that might be in the objdir or libdir directory
# Use this if you want to fully rebuild an executable (for a given compiler and or VERSION)
#
realclean: clean
	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v))
	rm -rf $(foreach v, $(VERSION), $(MAINLIBDIR)/$(ARCH)/$(v) $(EXEDIR)/*.$(v))
OTHER_HELP += "realclean : Remove all files for given ARCH and VERSION"

#
# Remove all files from previous builds
#
distclean: prettyclean doxifyclean
	rm -rf $(DOXYGENDIR) $(MAINEXEDIR) $(MAINOBJDIR) $(MAINLIBDIR) $(LIBCUSMM_DIR)/libcusmm.cu
OTHER_HELP += "distclean : Remove all files from previous builds"

#
# Remove ALL files not in SVN
# NOTE: This removes really everything not committed to SVN
#
mrproper:
	cd $(CP2KHOME); ./tools/clean_cwd.sh
OTHER_HELP += "mrproper : Remove ALL files not in SVN"

#
# instantiate the templates
#
vpath %.instantiation   $(ALL_SRC_DIRS)

# since the same named .instantiation file can be present in many directories, we need to copy the full tree
# to store the instantiated file in a unique location
# TODO: proper dependencies based on .template
instantiateddir:
	-rm -fR $(INSTANTIATEDDIR)
	@mkdir -p $(dir $(addprefix $(INSTANTIATEDDIR), $(ALL_INST_FILES:.instantiation=.instantiated)))

templates: instantiateddir $(addprefix $(INSTANTIATEDDIR), $(ALL_INST_FILES:.instantiation=.instantiated))
TOOL_HELP += "templates : instantiate all templates"

$(addprefix $(INSTANTIATEDDIR), %.instantiated): %.instantiation instantiateddir
	@cd $(dir $<); $(TOOLSRC)/instantiateTemplates.py $(notdir $<)
	@touch $@

# Prettyfier stuff ==========================================================
vpath %.pretty $(PRETTYOBJDIR)

prettydir:
	@mkdir -p $(PRETTYOBJDIR)

pretty: doxify prettydir $(addprefix $(PRETTYOBJDIR)/, $(ALL_OBJECTS:.o=.pretty))
TOOL_HELP += "pretty : Reformat all source files in a pretty way."

prettyclean:
	-rm -rf $(PRETTYOBJDIR) $(ALL_PREPRETTY_DIRS)
TOOL_HELP += "prettyclean : Remove prettify marker files and preprettify directories"

$(PRETTYOBJDIR)/%.pretty: %.F
	cd $(dir $<); $(TOOLSRC)/prettify.py $(notdir $<)
	@touch $@

$(PRETTYOBJDIR)/%.pretty: %.c
#   TODO: call indent here?
	@touch $@

# Doxyifier stuff ===========================================================
vpath %.doxified $(DOXIFYOBJDIR)

doxifydir:
	@mkdir -p $(DOXIFYOBJDIR)

doxify: doxifydir $(addprefix $(DOXIFYOBJDIR)/, $(ALL_OBJECTS:.o=.doxified))
TOOL_HELP += "doxify : Autogenerate doxygen headers for subroutines"

doxifyclean:
	-rm -rf $(DOXIFYOBJDIR)
TOOL_HELP += "doxifyclean : Remove doxify marker files"

$(DOXIFYOBJDIR)/%.doxified: %.F
	$(TOOLSRC)/doxify/doxify.sh $<
	@touch $@

$(DOXIFYOBJDIR)/%.doxified: %.c
	@touch $@

# doxygen stuff =============================================================
doxygen/clean:
	-rm -rf $(DOXYGENDIR)
TOOL_HELP += "doxygen/clean : Remove the generated doxygen documentation"

# Automatic source code documentation using Doxygen
# Prerequisites:
# - stable doxygen release 1.5.4 (Oct. 27, 2007)
# - graphviz (2.16.1)
# - webdot (2.16)
#
doxygen: doxygen/clean
	@mkdir -p $(DOXYGENDIR)
	@mkdir -p $(DOXYGENDIR)/html
	@echo "<html><body>Sorry, the Doxygen documentation is currently being updated. Please try again in a few minutes.</body></html>" > $(DOXYGENDIR)/html/index.html
	cp $(ALL_SRC_FILES) $(DOXYGENDIR)
	@for i in $(DOXYGENDIR)/*.F ; do mv $${i}  $${i%%.*}.f90; done ;
	@cat $(TOOLSRC)/doxify/Doxyfile.template | sed "s/#revision#/`$(TOOLSRC)/build_utils/get_revision_number $(CP2KHOME)`/"  >$(DOXYGENDIR)/Doxyfile
	cd $(DOXYGENDIR); doxygen ./Doxyfile 2>&1 | tee ./html/doxygen.out
TOOL_HELP += "doxygen : Generate the doxygen documentation"


# Libcusmm stuff ============================================================
$(LIBCUSMM_DIR)/libcusmm.cu: $(LIBCUSMM_DIR)/generate.py $(LIBCUSMM_DIR)/parameters.txt $(wildcard $(LIBCUSMM_DIR)/kernels/*.py)
	cd $(LIBCUSMM_DIR); ./generate.py $(LIBCUSMM_FLAGS)


# automatic dependency generation ===========================================
MAKEDEPMODE = "normal"
ifeq ($(HACKDEP),yes)
MAKEDEPMODE = "hackdep"
else
 ifneq ($(MC),)
 MAKEDEPMODE = "mod_compiler"
 endif
endif

# this happens on stage 3
makedep: $(ALL_SRC_FILES) $(ALL_PKG_FILES) dirs
ifeq ($(LD_SHARED),)
	@echo "Removing stale archives for $(ONEVERSION) ... "
	@$(TOOLSRC)/build_utils/check_archives.py $(firstword $(AR)) $(SRCDIR) $(LIBDIR)
endif
	@echo "Resolving dependencies for $(ONEVERSION) ... "
	@$(TOOLSRC)/build_utils/makedep.py $(OBJDIR)/all.dep $(MODDEPS) $(MAKEDEPMODE) $(ARCHIVE_EXT) $(OBJ_SRC_FILES)

# on stage 4, load the rules generated by makedep.py
ifeq ($(INCLUDE_DEPS), true)

=== tools/build_libsmm/libxsmm/Makefile ===

# Use ROW_MAJOR matrix representation if set to 1, COL_MAJOR otherwise 
ROW_MAJOR ?= 1

# M, N, K values of the generated matrices
INDICES_M ?= $(shell seq 1 8)
INDICES_N ?= $(shell seq 1 8)
INDICES_K ?= $(shell seq 1 8)

DIR_KNC   ?= .
SCRDIR_KNC = $(DIR_KNC)/scripts
OBJDIR_KNC = $(DIR_KNC)/build
INCDIR_KNC = $(DIR_KNC)/include
SRCDIR_KNC = $(DIR_KNC)/src
LIBDIR_KNC = $(DIR_KNC)/lib

INDICES ?= $(foreach m,$(INDICES_M),$(foreach n,$(INDICES_N),$(foreach k,$(INDICES_K),$m_$n_$k)))

TARGET_COMPILE_C_KNC := icc -offload-attribute-target=mic -mkl=sequential -std=c99 -openmp
AR := xiar -qoffload-build

SRCFILES_KNC = $(patsubst %,dc_small_dnn_%.c,$(INDICES))
OBJFILES_KNC = $(patsubst %,$(OBJDIR_KNC)/dc_small_dnn_%.o,$(INDICES))

LIB_KNC  ?= $(LIBDIR_KNC)/libxsmm.a
INC_KNC   = $(INCDIR_KNC)/xsmm_knc.h
MAIN_KNC  = $(SRCDIR_KNC)/xsmm_knc.c


lib_knc: $(LIB_KNC)
ifeq ($(origin NO_MAIN), undefined)
$(LIB_KNC): $(OBJFILES_KNC) $(patsubst $(SRCDIR_KNC)/%.c,$(OBJDIR_KNC)/%.o,$(MAIN_KNC))
else
$(LIB_KNC): $(OBJFILES_KNC)
endif
	@mkdir -p $(LIBDIR_KNC)
	$(AR) -rs $@ $^

compile_knc: $(OBJFILES_KNC)
$(OBJDIR_KNC)/%.o: $(SRCDIR_KNC)/%.c
	@mkdir -p $(OBJDIR_KNC)
	$(TARGET_COMPILE_C_KNC) -I$(INCDIR_KNC) -c $< -o $@

source_knc: $(addprefix $(SRCDIR_KNC)/,$(SRCFILES_KNC))
$(SRCDIR_KNC)/%.c:
	@mkdir -p $(SRCDIR_KNC)
	@python $(SCRDIR_KNC)/xsmm_knc_gensrc.py `echo $* | awk -F_ '{ print $$4" "$$5" "$$6 }'` $(ROW_MAJOR) > $@

main_knc: $(MAIN_KNC)
$(MAIN_KNC): $(INC_KNC)
	@mkdir -p $(SRCDIR_KNC)
	@python $(SCRDIR_KNC)/xsmm_knc_genmain.py $(words $(INDICES_M)) $(words $(INDICES_N)) $(ROW_MAJOR) $(INDICES_M) $(INDICES_N) $(INDICES_K) > $@

header_knc: $(INC_KNC)
$(INC_KNC):
	@echo "#ifndef XSMM_KNC_H" > $@
	@echo "#define XSMM_KNC_H" >> $@
	@echo >> $@
	@python $(SCRDIR_KNC)/xsmm_knc_geninc.py >> $@
	@python $(SCRDIR_KNC)/xsmm_knc_geninc.py $(INDICES) >> $@
	@echo >> $@
	@echo "#endif // XSMM_KNC_H" >> $@

clean:
	rm -rf $(SRCDIR_KNC) $(OBJDIR_KNC) $(DIR_KNC)/*~ $(DIR_KNC)/*/*~

realclean: clean
	rm -rf $(LIBDIR_KNC) $(INC_KNC)

=== debian/changelog ===
cp2k (2.6.2-3) unstable; urgency=medium

  * debian/patches/makeflags.patch: Switch to ELPA2.
  * debian/control (Build-Depends): Bump libelpa-dev to 2015.05.001.
  * debian/control (Build-Depends): Tighten libelpa-dev version to -3 where the
    modules are installed at the usual location again (Closes: #816086).

 -- Michael Banck <mbanck@debian.org>  Sat, 27 Feb 2016 19:06:01 +0100

cp2k (2.6.2-2) unstable; urgency=medium

  * debian/patches/elpa2_support.patch: New patch to support ELPA2 interface,
    taken from upstream revisions 15202 and 15213.
  * debian/patches/makeflags.patch: Updated for openmpi-1.10, thanks to
    Alastair McKinstry (Closes: #813799).
  * debian/control (Build-Depends): Added pkg-config.

 -- Michael Banck <mbanck@debian.org>  Sun, 07 Feb 2016 13:05:29 +0100

cp2k (2.6.2-1) unstable; urgency=medium
 
  * New upstream point release.

 -- Michael Banck <mbanck@debian.org>  Sun, 22 Nov 2015 19:07:47 +0100

=== debian/control ===
Source: cp2k
Section: science
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: bc,
               bison,
               debhelper (>= 7.0.50~),
               default-jre-headless,
               flex,
               python, 
               gfortran,
               libblas-dev,
               libelpa-dev (>= 2015.05.001-3),
               libfftw3-dev,
               libint-dev,
               liblapack-dev,
               libsaxonb-java,
               libscalapack-mpi-dev,
               libxc-dev,
               mpi-default-dev,
	       pkg-config
Standards-Version: 3.9.4
Homepage: http://www.cp2k.org
Vcs-Browser: http://anonscm.debian.org/viewvc/debichem/unstable/cp2k/
Vcs-Svn: svn://anonscm.debian.org/debichem/unstable/cp2k/

Package: cp2k
Architecture: any
Depends: cp2k-data (= ${source:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Ab Initio Molecular Dynamics
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-initio molecular
 dynamics (AIMD) simulations. 
 .
 CP2K is optimized for the mixed Gaussian and Plane-Waves (GPW) method based on
 pseudopotentials, but is able to run all-electron or pure plane-wave/Gaussian
 calculations as well. Features include:
 .
 Ab-initio Electronic Structure Theory Methods using the QUICKSTEP module:
 .
  * Density-Functional Theory (DFT) energies and forces
  * Hartree-Fock (HF) energies and forces
  * Moeller-Plesset 2nd order perturbation theory (MP2) energies and forces
  * Random Phase Approximation (RPA) energies
  * Gas phase or Periodic boundary conditions (PBC)
  * Basis sets include various standard Gaussian-Type Orbitals (GTOs), Pseudo-
    potential plane-waves (PW), and a mixed Gaussian and (augmented) plane wave
    approach (GPW/GAPW)
  * Norm-conserving, seperable Goedecker-Teter-Hutter (GTH) and non-linear core
    corrected (NLCC) pseudopotentials, or all-electron calculations
  * Local Density Approximation (LDA) XC functionals including SVWN3, SVWN5,
    PW92 and PADE
  * Gradient-corrected (GGA) XC functionals including BLYP, BP86, PW91, PBE and
    HCTH120 as well as the meta-GGA XC functional TPSS
  * Hybrid XC functionals with exact Hartree-Fock Exchange (HFX) including
    B3LYP, PBE0 and MCY3
  * Double-hybrid XC functionals including B2PLYP and B2GPPLYP
  * Additional XC functionals via LibXC
  * Dispersion corrections via DFT-D2 and DFT-D3 pair-potential models
  * Non-local van der Waals corrections for XC functionals including B88-vdW,
    PBE-vdW and B97X-D
  * DFT+U (Hubbard) correction
  * Density-Fitting for DFT via Bloechl or Density Derived Atomic Point Charges
    (DDAPC) charges, for HFX via Auxiliary Density Matrix Methods (ADMM) and
    for MP2/RPA via Resolution-of-identity (RI)
  * Sparse matrix and prescreening techniques for linear-scaling Kohn-Sham (KS)
    matrix computation
  * Orbital Transformation (OT) or Direct Inversion of the iterative subspace
    (DIIS) self-consistent field (SCF) minimizer
  * Local Resolution-of-Identity Projector Augmented Wave method (LRIGPW)
  * Absolutely Localized Molecular Orbitals SCF (ALMO-SCF) energies for linear
    scaling of molecular systems
  * Excited states via time-dependent density-functional perturbation theory
    (TDDFPT)
 .
 Ab-initio Molecular Dynamics:
 .
  * Born-Oppenheimer Molecular Dynamics (BOMD)
  * Ehrenfest Molecular Dynamics (EMD)
  * PS extrapolation of initial wavefunction
  * Time-reversible Always Stable Predictor-Corrector (ASPC) integrator
  * Approximate Car-Parrinello like Langevin Born-Oppenheimer Molecular Dynamics
    (Second-Generation Car-Parrinello Molecular Dynamics)
 .
 Mixed quantum-classical (QM/MM) simulations:
 .
  * Real-space multigrid approach for the evaluation of the Coulomb
    interactions between the QM and the MM part
  * Linear-scaling electrostatic coupling treating of periodic boundary
    conditions
  * Adaptive QM/MM
 .
 Further Features include:
 .
  * Single-point energies, geometry optimizations and frequency calculations
  * Several nudged-elastic band (NEB) algorithms (B-NEB, IT-NEB, CI-NEB, D-NEB)
    for minimum energy path (MEP) calculations
  * Global optimization of geometries
  * Solvation via the Self-Consistent Continuum Solvation (SCCS) model
  * Semi-Empirical calculations including the AM1, RM1, PM3, MNDO, MNDO-d, PNNL
    and PM6 parametrizations, density-functional tight-binding (DFTB) and
    self-consistent-polarization tight-binding (SCP-TB), with or without
    periodic boundary conditions
  * Classical Molecular Dynamics (MD) simulations in microcanonical ensemble
    (NVE) or canonical ensmble (NVT) with Nose-Hover and canonical sampling
    through velocity rescaling (CSVR) thermostats
  * Metadynamics including well-tempered Metadynamics for Free Energy
    calculations
  * Classical Force-Field (MM) simulations
  * Monte-Carlo (MC) KS-DFT simulations
  * Static (e.g. spectra) and dynamical (e.g. diffusion) properties
  * ATOM code for pseudopotential generation
  * Integrated molecular basis set optimization
 .
 CP2K does not implement conventional Car-Parrinello Molecular Dynamics (CPMD).

Package: cp2k-data
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ab Initio Molecular Dynamics (data files)
 CP2K is a program to perform simulations of solid state, liquid, molecular and
 biological systems. It is especially aimed at massively parallel and linear
 scaling electronic structure methods and state-of-the-art ab-inito molecular
 dynamics (AIMD) simulations.
 .
 This package contains basis sets, pseudopotentials and force-field parameters.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/mpi-default-dev/debian_defaults

DEB_BUILD_ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)

ifeq ($(DEB_BUILD_ARCH), i386)
    export FFTW3_ALIGN=-D__FFTW3_UNALIGNED
else
    export FFTW3_ALIGN=
endif

export LIB_SCALAPACK=-lscalapack-$(ARCH_DEFAULT_MPI_IMPL)
export LIB_BLACS=-lblacsCinit-$(ARCH_DEFAULT_MPI_IMPL) -lblacs-$(ARCH_DEFAULT_MPI_IMPL)
export OMPI_MCA_orte_rsh_agent=/bin/false

PLATFORM=Linux
ARCH=`uname -m`
FORT_C_NAME=gfortran
VERSION=popt

%:
	dh $@ 

override_dh_auto_clean:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).$(VERSION)		   \
		$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).$(VERSION))
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME)		   \
		VERSION=$(VERSION) distclean)
	(cd tools/manual; rm -rf CP2K_INPUT; rm -f *.html *.xml)
	rm -f arch/$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).*
	rm -rf LAST* TEST*
	dh_auto_clean

override_dh_auto_build:
	(cd arch; ln -fs $(PLATFORM)-generic-$(FORT_C_NAME).$(VERSION)		    \
		$(PLATFORM)-$(ARCH)-$(FORT_C_NAME).$(VERSION))
	(cd makefiles; $(MAKE) ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) 		    \
		VERSION=$(VERSION) all)
	(cd tools/manual; $(CURDIR)/exe/*/cp2k.$(VERSION) --xml)
	(cd tools/manual; saxonb-xslt -o index.html -ext:on cp2k_input.xml cp2k_input.xsl)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	ln -nfs testresults LAST-$(PLATFORM)-$(ARCH)-$(FORT_C_NAME)-$(VERSION)
	-(cd tools/regtesting; ARCH=$(PLATFORM)-$(ARCH)-$(FORT_C_NAME) ./do_regtest \
		-config ../../debian/regtest.config                                 \
		-restrictdir ATOM/regtest-2                                         \
		-restrictdir DFTB/regtest-nonscc                                    \
		-restrictdir EP                                                     \
		-restrictdir FARMING/regtest-1                                      \
		-restrictdir FE/regtest-2                                           \
		-restrictdir FE/regtest-3                                           \
		-restrictdir Fist/regtest-11                                        \
		-restrictdir LIBTEST                                                \
		-restrictdir MC/regtest                                             \
		-restrictdir NEB/regtest-1                                          \
		-restrictdir NEB/regtest-3                                          \
		-restrictdir optimize_input/regtest-1                               \
		-restrictdir Pimd                                                   \
		-restrictdir QMMM/QS/regtest-2-erf                                  \
		-restrictdir QMMM/QS/regtest-gapw                                   \
		-restrictdir QMMM/SE/regtest_2                                      \
		-restrictdir QMMM/DFTB/regtest                                      \
		-restrictdir QS/regtest-almo                                        \
		-restrictdir QS/regtest-epr-2                                       \
		-restrictdir QS/regtest-gapw-2                                      \
		-restrictdir QS/regtest-gpw-2-1                                     \
		-restrictdir QS/regtest-gpw-6-4                                     \
		-restrictdir QS/regtest-hirschfeld                                  \
		-restrictdir QS/regtest-hfx-periodic                                \
		-restrictdir QS/regtest-hfx-stress                                  \
		-restrictdir QS/regtest-hybrid-1                                    \
		-restrictdir QS/regtest-linearscaling                               \
		-restrictdir QS/regtest-libxc                                       \
		-restrictdir QS/regtest-lsroks                                      \
		-restrictdir QS/regtest-md-lgvregion                                \
		-restrictdir QS/regtest-mp2-1                                       \
		-restrictdir QS/regtest-mp2-grad                                    \
		-restrictdir QS/regtest-nmr-2                                       \
		-restrictdir QS/regtest-optbas                                      \
		-restrictdir QS/regtest-ot-refine-3                                 \
		-restrictdir QS/regtest-p-efield                                    \
		-restrictdir QS/regtest-polar                                       \
		-restrictdir QS/regtest-properties/resp                             \
		-restrictdir QS/regtest-sccs                                        \
		-restrictdir SCPTB/regtest-1                                        \
		-restrictdir SE/regtest-3-1                                         \
		-restrictdir SWARM/regtest-glbopt-1 )
endif

## cp2k 3.0.0

=== makefiles/Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #
 # will now perform a parallel build of 4 cp2k executables
 #
-.SUFFIXES: .F .dep .o .f90 .cu .c .instantiation .instantiated .template
+.SUFFIXES: .F .dep .o .f90 .cu .c .cpp .cxx .cc .instantiation .instantiated .template
 SHELL = /bin/sh
 #
 # the home dir is taken from the current directory: you must cd to the makefiles
@@ -12,14 +12,16 @@
 # also works fine
 #
 CP2KHOME     := $(abspath $(PWD)/..)
-ARCH         := $(shell $(CP2KHOME)/tools/build_utils/get_arch_code)
+ARCH         := local
 export VERSION=sopt
 
 MAKEFILE     := $(CP2KHOME)/makefiles/Makefile
 DOXYGENDIR   := $(CP2KHOME)/doc/doxygen
+DATA_DIR     := $(CP2KHOME)/data
 MAINEXEDIR   := $(CP2KHOME)/exe
 MAINLIBDIR   := $(CP2KHOME)/lib
 MAINOBJDIR   := $(CP2KHOME)/obj
+MAINTSTDIR   := $(CP2KHOME)/regtesting
 PRETTYOBJDIR := $(CP2KHOME)/obj/prettified
 DOXIFYOBJDIR := $(CP2KHOME)/obj/doxified
 INSTANTIATEDDIR := $(CP2KHOME)/obj/instantiated
@@ -42,6 +44,7 @@
 include $(CP2KHOME)/arch/$(ARCH).$(ONEVERSION)
 LIBDIR  := $(MAINLIBDIR)/$(ARCH)/$(ONEVERSION)
 OBJDIR  := $(MAINOBJDIR)/$(ARCH)/$(ONEVERSION)
+TSTDIR  := $(MAINTSTDIR)/$(ARCH)/$(ONEVERSION)
 ifeq ($(NVCC),)
 EXE_NAMES := $(basename $(notdir $(filter-out %.cu, $(ALL_EXE_FILES))))
 endif
@@ -56,10 +59,11 @@
 .PHONY : $(VERSION) $(EXE_NAMES) \
          dirs makedep default_target all \
          toolversions libcp2k \
-         doxifydir doxify doxifyclean \
-         prettydir pretty prettyclean doxygen/clean doxygen \
+         doxify doxifyclean \
+         pretty prettyclean doxygen/clean doxygen \
          install clean realclean distclean mrproper help templates \
-         instantiationdir templatesclean
+         instantiationdir templatesclean \
+         test testbg testclean testrealclean
 
 
 # Discover files and directories ============================================
@@ -70,6 +74,9 @@
 ALL_PKG_FILES  = $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "PACKAGE")
 OBJ_SRC_FILES  = $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.F")
 OBJ_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.c")
+OBJ_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.cpp")
+OBJ_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.cxx")
+OBJ_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.cc")
 ALL_INST_FILES = $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.instantiation")
 
 ifneq ($(NVCC),)
@@ -81,6 +88,9 @@
 ALL_SRC_FILES  = $(OBJ_SRC_FILES)
 ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.f90")
 ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.h")
+ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.hpp")
+ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.hxx")
+ALL_SRC_FILES += $(shell find $(SRCDIR) ! -path "*/preprettify/*" -name "*.hcc")
 
 ALL_OBJECTS        = $(addsuffix .o, $(basename $(notdir $(OBJ_SRC_FILES))))
 ALL_EXE_OBJECTS    = $(addsuffix .o, $(EXE_NAMES))
@@ -98,7 +108,7 @@
 fes :
 	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(VERSION) ORIG_TARGET=graph
 
-$(EXE_NAMES) all toolversions libcp2k:
+$(EXE_NAMES) all toolversions libcp2k test testbg:
 	@+$(MAKE) --no-print-directory -f $(MAKEFILE) $(VERSION) ORIG_TARGET=$@
 
 # stage 2: Store the version target in $(ONEVERSION),
@@ -117,13 +127,21 @@
 all: dirs makedep
 	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) all INCLUDE_DEPS=true
 
+test: dirs makedep all
+	@+$(MAKE) --no-print-directory -C $(TSTDIR) -f $(MAKEFILE) test INCLUDE_DEPS=true
+
+testbg: dirs makedep all
+	@+$(MAKE) --no-print-directory -C $(TSTDIR) -f $(MAKEFILE) testbg INCLUDE_DEPS=true
+
 libcp2k: dirs makedep
 	@+$(MAKE) --no-print-directory -C $(OBJDIR) -f $(MAKEFILE) $(LIBDIR)/libcp2k$(ARCHIVE_EXT) INCLUDE_DEPS=true
+
 
 dirs:
 	@mkdir -p $(OBJDIR)
 	@mkdir -p $(LIBDIR)
 	@mkdir -p $(EXEDIR)
+	@mkdir -p $(TSTDIR)
 
 toolversions:
 ifneq ($(FC),)
@@ -150,8 +168,23 @@
 all: $(foreach e, $(EXE_NAMES), $(EXEDIR)/$(e).$(ONEVERSION))
 $(LIBDIR)/libcp2k$(ARCHIVE_EXT) : $(ALL_NONEXE_OBJECTS)
 
-endif
-endif
+# ================= testing ===============
+test:
+	$(TOOLSRC)/regtesting/do_regtest -nobuild -nosvn -arch $(ARCH) -version $(ONEVERSION) -cp2kdir ../../../  $(TESTOPTS)
+
+testbg:
+	@echo "testing: $(ONEVERSION) : full log in $(TSTDIR)/regtest.log "
+	@$(TOOLSRC)/regtesting/do_regtest -nobuild -nosvn -arch $(ARCH) -version $(ONEVERSION) -cp2kdir ../../../  $(TESTOPTS) >& $(TSTDIR)/regtest.log 
+	@cat `grep 'regtesting location error_summary file:' $(TSTDIR)/regtest.log | awk '{print $$NF}'`
+	@cat `grep 'regtesting location summary file:' $(TSTDIR)/regtest.log | awk '{print $$NF}'`
+	@grep "Number of FAILED  tests 0" $(TSTDIR)/regtest.log >& /dev/null
+	@grep "Number of WRONG   tests 0" $(TSTDIR)/regtest.log >& /dev/null
+
+endif
+endif
+
+OTHER_HELP += "test : run the regression tests"
+OTHER_HELP += "testbg : run the regression tests in background"
 
 OTHER_HELP += "toolversions : Print versions of build tools"
 
@@ -187,26 +220,38 @@
 #
 # cleaning stuff ============================================================
 clean:
-	rm -rf  $(LIBCUSMM_DIR)/libcusmm.cu
+	rm -rf  $(LIBCUSMM_DIR)/libcusmm.cu $(LIBCUSMM_DIR)/libcusmm_part*.cu
 	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.o)
-	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.mod $(MAINOBJDIR)/$(ARCH)/$(v)/*.MOD) 
+	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.mod $(MAINOBJDIR)/$(ARCH)/$(v)/*.MOD $(MAINOBJDIR)/$(ARCH)/$(v)/*.smod) 
 	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.dep) 
 OTHER_HELP += "clean : Remove intermediate object and mod files, but not the libraries and executables, for given ARCH and VERSION"
 
+execlean:
+	rm -rf $(foreach v, $(VERSION), $(EXEDIR)/*.$(v))
+OTHER_HELP += "execlean : Remove the executables, for given ARCH and VERSION"
+
 #
 # delete the intermediate files, the programs and libraries and anything that might be in the objdir or libdir directory
 # Use this if you want to fully rebuild an executable (for a given compiler and or VERSION)
 #
-realclean: clean
+realclean: clean execlean
 	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v))
-	rm -rf $(foreach v, $(VERSION), $(MAINLIBDIR)/$(ARCH)/$(v) $(EXEDIR)/*.$(v))
+	rm -rf $(foreach v, $(VERSION), $(MAINLIBDIR)/$(ARCH)/$(v))
 OTHER_HELP += "realclean : Remove all files for given ARCH and VERSION"
 
+testclean:
+	rm -rf $(foreach v, $(VERSION), $(MAINTSTDIR)/$(ARCH)/$(v)/TEST-*)
+OTHER_HELP += "testclean : Remove all TEST-* files for given ARCH and VERSION"
+
+testrealclean: testclean
+	rm -rf $(foreach v, $(VERSION), $(MAINTSTDIR)/$(ARCH)/$(v)/LAST-*)
+OTHER_HELP += "testrealclean : Remove all LAST-* and TEST-* files for given ARCH and VERSION"
+
 #
 # Remove all files from previous builds
 #
-distclean: prettyclean doxifyclean
-	rm -rf $(DOXYGENDIR) $(MAINEXEDIR) $(MAINOBJDIR) $(MAINLIBDIR) $(LIBCUSMM_DIR)/libcusmm.cu
+distclean: prettyclean doxifyclean testrealclean
+	rm -rf $(DOXYGENDIR) $(MAINEXEDIR) $(MAINOBJDIR) $(MAINLIBDIR) $(MAINTSTDIR) $(LIBCUSMM_DIR)/libcusmm.cu
 OTHER_HELP += "distclean : Remove all files from previous builds"
 
 #
@@ -233,95 +278,27 @@
 TOOL_HELP += "templates : instantiate all templates"
 
 $(addprefix $(INSTANTIATEDDIR), %.instantiated): %.instantiation instantiateddir
-	@cd $(dir $<); $(TOOLSRC)/instantiateTemplates.py $(notdir $<)
+	@cd $(dir $<); $(TOOLSRC)/instantiateTemplates.py --backup-dir=$(PRETTYOBJDIR) $(notdir $<)
 	@touch $@
 
 # Prettyfier stuff ==========================================================
 vpath %.pretty $(PRETTYOBJDIR)
 
-prettydir:
-	@mkdir -p $(PRETTYOBJDIR)
-
-pretty: doxify prettydir $(addprefix $(PRETTYOBJDIR)/, $(ALL_OBJECTS:.o=.pretty))
+pretty: $(addprefix $(PRETTYOBJDIR)/, $(ALL_OBJECTS:.o=.pretty))
 TOOL_HELP += "pretty : Reformat all source files in a pretty way."
 
 prettyclean:
 	-rm -rf $(PRETTYOBJDIR) $(ALL_PREPRETTY_DIRS)
 TOOL_HELP += "prettyclean : Remove prettify marker files and preprettify directories"
 
-$(PRETTYOBJDIR)/%.pretty: %.F
-	cd $(dir $<); $(TOOLSRC)/prettify.py $(notdir $<)
+$(PRETTYOBJDIR)/%.pretty: %.F $(DOXIFYOBJDIR)/%.doxified
+	@mkdir -p $(PRETTYOBJDIR)
+	cd $(dir $<); $(TOOLSRC)/prettify.py --backup-dir=$(PRETTYOBJDIR) $(notdir $<)
 	@touch $@
 
-$(PRETTYOBJDIR)/%.pretty: %.c
+$(PRETTYOBJDIR)/%.pretty: %.c $(DOXIFYOBJDIR)/%.doxified
 #   TODO: call indent here?
+	@mkdir -p $(PRETTYOBJDIR)
 	@touch $@
 
-# Doxyifier stuff ===========================================================
-vpath %.doxified $(DOXIFYOBJDIR)
-
-doxifydir:
-	@mkdir -p $(DOXIFYOBJDIR)
-
-doxify: doxifydir $(addprefix $(DOXIFYOBJDIR)/, $(ALL_OBJECTS:.o=.doxified))
-TOOL_HELP += "doxify : Autogenerate doxygen headers for subroutines"
-
-doxifyclean:
-	-rm -rf $(DOXIFYOBJDIR)
-TOOL_HELP += "doxifyclean : Remove doxify marker files"
-
-$(DOXIFYOBJDIR)/%.doxified: %.F
-	$(TOOLSRC)/doxify/doxify.sh $<
-	@touch $@
-
-$(DOXIFYOBJDIR)/%.doxified: %.c
-	@touch $@
-
-# doxygen stuff =============================================================
-doxygen/clean:
-	-rm -rf $(DOXYGENDIR)
-TOOL_HELP += "doxygen/clean : Remove the generated doxygen documentation"
-
-# Automatic source code documentation using Doxygen
-# Prerequisites:
-# - stable doxygen release 1.5.4 (Oct. 27, 2007)
-# - graphviz (2.16.1)
-# - webdot (2.16)
-#
-doxygen: doxygen/clean
-	@mkdir -p $(DOXYGENDIR)
-	@mkdir -p $(DOXYGENDIR)/html
-	@echo "<html><body>Sorry, the Doxygen documentation is currently being updated. Please try again in a few minutes.</body></html>" > $(DOXYGENDIR)/html/index.html
-	cp $(ALL_SRC_FILES) $(DOXYGENDIR)
-	@for i in $(DOXYGENDIR)/*.F ; do mv $${i}  $${i%%.*}.f90; done ;
-	@cat $(TOOLSRC)/doxify/Doxyfile.template | sed "s/#revision#/`$(TOOLSRC)/build_utils/get_revision_number $(CP2KHOME)`/"  >$(DOXYGENDIR)/Doxyfile
-	cd $(DOXYGENDIR); doxygen ./Doxyfile 2>&1 | tee ./html/doxygen.out
-TOOL_HELP += "doxygen : Generate the doxygen documentation"
-
-
-# Libcusmm stuff ============================================================
-$(LIBCUSMM_DIR)/libcusmm.cu: $(LIBCUSMM_DIR)/generate.py $(LIBCUSMM_DIR)/parameters.txt $(wildcard $(LIBCUSMM_DIR)/kernels/*.py)
-	cd $(LIBCUSMM_DIR); ./generate.py $(LIBCUSMM_FLAGS)
-
-
-# automatic dependency generation ===========================================
-MAKEDEPMODE = "normal"
-ifeq ($(HACKDEP),yes)
-MAKEDEPMODE = "hackdep"
-else
- ifneq ($(MC),)
- MAKEDEPMODE = "mod_compiler"
- endif
-endif
-
-# this happens on stage 3
-makedep: $(ALL_SRC_FILES) $(ALL_PKG_FILES) dirs
-ifeq ($(LD_SHARED),)
-	@echo "Removing stale archives for $(ONEVERSION) ... "
-	@$(TOOLSRC)/build_utils/check_archives.py $(firstword $(AR)) $(SRCDIR) $(LIBDIR)
-endif
-	@echo "Resolving dependencies for $(ONEVERSION) ... "
-	@$(TOOLSRC)/build_utils/makedep.py $(OBJDIR)/all.dep $(MODDEPS) $(MAKEDEPMODE) $(ARCHIVE_EXT) $(OBJ_SRC_FILES)
-
-# on stage 4, load the rules generated by makedep.py
-ifeq ($(INCLUDE_DEPS), true)
+$(PRETTYOBJDIR)/%.pretty: %.cpp $(DOXIFYOBJDIR)/%.doxified

=== debian/changelog ===
cp2k (3.0.0-1build1) zesty; urgency=medium

  * No-change rebuild against libopenmpi2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 22 Oct 2016 01:23:06 +0000

cp2k (3.0.0-1) unstable; urgency=medium

  * New upstream release, new features include:
    + K-points for GGA DFT
    + Unrestricted MP2 gradients
    + Implicit Poisson solver, with dielectric, and different boundary
      conditions
    + Improvements in the path integral code, including the PIGLET thermostat
    + G0W0 and eigenvalue self-consistent GW
    + Filtered basis method
    + Polarized atomic orbitals
  * debian/patches/testsuite_output.patch: Refreshed.
  * debian/patches/elpa2_support.patch: Removed, no longer needed.
  * debian/patches/data_files_standard_location.patch: Likewise.
  * debian/control (Build-Depends): Bump libelpa-dev dependency to
    2016.05.001-1.
  * debian/patches/makeflags.patch: Update ELPA define to __ELPA3.
  * debian/patches/makeflags.patch: Add /usr/include to include path for
    LibXC's Fortran90 modules.
  * debian/patches/makeflags.patch: Add LibXC's Fortran90 to LIBS.
  * debian/patches/libxc3_support.patch: New patch, conditionalize XC
    functional names according to major version.
  * debian/control (Build-Depends): Bump libxc-dev dependency to
    3.0.0-1.
  * debian/cp2k.examples: Replaced no longer present He-ri.inp example with
    H2O-hfx-1.inp.
  * debian/rules (override_dh_auto_test): Update list of regression test
    directories.
  * debian/regtest.config: Add numprocs=1 to regression tester config.

 -- Michael Banck <mbanck@debian.org>  Sun, 29 May 2016 16:21:00 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: cp2k
 Section: science
 Priority: optional
-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: bc,
                bison,
@@ -11,13 +12,13 @@
                python, 
                gfortran,
                libblas-dev,
-               libelpa-dev (>= 2015.05.001-3),
+               libelpa-dev (>= 2016.05.001-1),
                libfftw3-dev,
                libint-dev,
                liblapack-dev,
                libsaxonb-java,
                libscalapack-mpi-dev,
-               libxc-dev,
+               libxc-dev (>= 3.0.0-1),
                mpi-default-dev,
 	       pkg-config
 Standards-Version: 3.9.4

## cp2k 4.1

=== makefiles/Makefile ===
--- 
+++ 
@@ -162,6 +162,13 @@
 	$(firstword $(AR)) V
 	@echo ""
 endif
+	@echo "========== Make ($(ONEVERSION)) =========="
+	$(MAKE) --version
+	@echo ""
+	@echo "========= Python ($(ONEVERSION)) ========="
+	/usr/bin/env python --version
+	@echo ""
+
 else
 
 # stage 4: Include $(OBJDIR)/all.dep, expand target all and libcp2k, and perform actual build.
@@ -174,7 +181,7 @@
 
 testbg:
 	@echo "testing: $(ONEVERSION) : full log in $(TSTDIR)/regtest.log "
-	@$(TOOLSRC)/regtesting/do_regtest -nobuild -nosvn -arch $(ARCH) -version $(ONEVERSION) -cp2kdir ../../../  $(TESTOPTS) >& $(TSTDIR)/regtest.log 
+	@$(TOOLSRC)/regtesting/do_regtest -nobuild -nosvn -arch $(ARCH) -version $(ONEVERSION) -cp2kdir ../../../  $(TESTOPTS) >& $(TSTDIR)/regtest.log
 	@cat `grep 'regtesting location error_summary file:' $(TSTDIR)/regtest.log | awk '{print $$NF}'`
 	@cat `grep 'regtesting location summary file:' $(TSTDIR)/regtest.log | awk '{print $$NF}'`
 	@grep "Number of FAILED  tests 0" $(TSTDIR)/regtest.log >& /dev/null
@@ -222,8 +229,8 @@
 clean:
 	rm -rf  $(LIBCUSMM_DIR)/libcusmm.cu $(LIBCUSMM_DIR)/libcusmm_part*.cu
 	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.o)
-	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.mod $(MAINOBJDIR)/$(ARCH)/$(v)/*.MOD $(MAINOBJDIR)/$(ARCH)/$(v)/*.smod) 
-	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.dep) 
+	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.mod $(MAINOBJDIR)/$(ARCH)/$(v)/*.MOD $(MAINOBJDIR)/$(ARCH)/$(v)/*.smod)
+	rm -rf $(foreach v, $(VERSION), $(MAINOBJDIR)/$(ARCH)/$(v)/*.dep)
 OTHER_HELP += "clean : Remove intermediate object and mod files, but not the libraries and executables, for given ARCH and VERSION"
 
 execlean:
@@ -278,7 +285,7 @@
 TOOL_HELP += "templates : instantiate all templates"
 
 $(addprefix $(INSTANTIATEDDIR), %.instantiated): %.instantiation instantiateddir
-	@cd $(dir $<); $(TOOLSRC)/instantiateTemplates.py --backup-dir=$(PRETTYOBJDIR) $(notdir $<)
+	@cd $(dir $<); $(TOOLSRC)/instantiateTemplates.py $(notdir $<)
 	@touch $@
 
 # Prettyfier stuff ==========================================================
@@ -293,12 +300,6 @@
 
 $(PRETTYOBJDIR)/%.pretty: %.F $(DOXIFYOBJDIR)/%.doxified
 	@mkdir -p $(PRETTYOBJDIR)
-	cd $(dir $<); $(TOOLSRC)/prettify.py --backup-dir=$(PRETTYOBJDIR) $(notdir $<)
+	cd $(dir $<); $(TOOLSRC)/prettify/fprettify.py --do-backup --backup-dir=$(PRETTYOBJDIR) $(notdir $<)
 	@touch $@
 
-$(PRETTYOBJDIR)/%.pretty: %.c $(DOXIFYOBJDIR)/%.doxified
-#   TODO: call indent here?
-	@mkdir -p $(PRETTYOBJDIR)
-	@touch $@
-
-$(PRETTYOBJDIR)/%.pretty: %.cpp $(DOXIFYOBJDIR)/%.doxified

=== tools/cubecruncher/Makefile ===
#
# setting for various compilers
# files should be standard f90 + getarg / iargc
#

FC=xlf90
FCFLAGS=-O2 -qsuffix=f=f90 -qmaxmem=128000 -bmaxdata:1000000000 -bmaxstack:128000000 

FC=ifc
FCFLAGS=-O2 -Vaxlib 

FC=ifort
FCFLAGS=-O2 

FC=pgf90
FCFLAGS=-O2 

FC=g95
FCFLAGS=-O2 

FC=gfortran
FCFLAGS=-O2 

EXE=-o cubecruncher.x

#
# should not require modification
#
cubecruncher.x: utils.f90 periodic_table.f90 cubecruncher.f90 Makefile
	$(FC) $(FCFLAGS) $(EXE) utils.f90 periodic_table.f90 cubecruncher.f90

clean:
	rm -f *.MOD *.mod *.o core

distclean:
	rm -f *.MOD *.mod *.o core *.x

=== debian/changelog ===
cp2k (4.1-1) unstable; urgency=medium

  * New upstream release, new features include:
    + Cubic-scaling RPA
    + Maximum Overlap Method (MOM)
    + Polarized Atomic Orbitals from Machine Learning (PAO-ML)
    + Modified Atomic Orbitals (MAO) Analysis
    + Improved linear scaling (LS) DFT MD with curvy steps
    + GTH-PBE pseudopotentials for the Lanthanide elements
    + Fast method for periodic ERI reducing overhead of image charge correction
      in QM/MM and used in cubic-scaling RPA
    + Additional collective variables
  * debian/patches/libxc3_support.patch: Refreshed.
  * debian/rules (override_dh_auto_test): No longer symlink in testresults.
  * debian/patches/makeflags.patch: Updated, DATA_DIR is now a top-level
    variable.
  * debian/rules (CP2K_DATA_DIR): New variable, overrides DATA_DIR to the local
    directory for the testsuite.
 
 -- Michael Banck <mbanck@debian.org>  Wed, 05 Oct 2016 23:49:21 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: cp2k
 Section: science
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
+Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
 Uploaders: Michael Banck <mbanck@debian.org>
 Build-Depends: bc,
                bison,
